<template>
    <div class="d-md-flex align-items-center flex-wrap justify-content-center mt-4 p-3 pb-3 contenedorPrincipal">
        <label class="form-label mx-2">Fecha Desde:</label>
        <input type="date" v-model="data.fecha_desde" class="form-label me-2 " id="fecha_desde" autocomplete="off" />

        <label class="form-label mx-2">Fecha Hasta:</label>
        <input type="date" v-model="data.fecha_hasta" class="form-label me-2" id="fecha_hasta" autocomplete="off" />

        <label class="form-label mx-2">Cargo:</label>
        <auto-complete style="position: relative; top:-5px" class="me-2" v-model="data.cargo"
            :elements="cuposStore.listadoCargos" placeholder="Cargo" :minLength="3" :disabled="false" />

        <button type="button" class="btn btn-principal px-2 mx-5" @click="busquedaCupos()">
            <i class="bi bi-search"></i>
        </button>
    </div>
</template>

<script setup lang="ts">
//librerias
import { reactive, watch, ref, onMounted } from "vue";
import { useRoute, useRouter } from "vue-router";
import { loading } from "@/shared.js";
import { AutoComplete } from "@hcd-bsas/vue3-components";

//components

//store
import { useCuposStore } from "@/stores/Cupos/cupos";
import { useConfigStore } from "@/stores/configgral";
//entities
import type Cargo from "@/entities/Cupos/Cargo";



const router = useRouter();
const route = useRoute();

const cuposStore = useCuposStore();
const configStore = useConfigStore();

const data = reactive({
    fecha_desde: "" as string,
    fecha_hasta: "" as string,
    cargo: null as Cargo | null
});


onMounted(async () => {

    loading.show();
    await configStore.updateListadoPeriodo();
    var anio = configStore.listadoPeriodoActivo[0]?.anioActivo;
    data.fecha_desde = anio + "-03-01";
    data.fecha_hasta = anio + "-12-31";

    await cuposStore.updateListadoCargos({
        periodo: anio,
        viene_de: 'B'
    });
    await busquedaCupos();
    loading.hide();
});



async function busquedaCupos() {
    loading.show();

    await cuposStore.updateListadoCargosCabecera({
        id_cargo: data.cargo?.id_cargo,
        id_tabla_sol: data.cargo?.id_tabla_sol,
        tipo_transf: "C",
        f_transf_desde: data.fecha_desde,
        f_transf_hasta: data.fecha_hasta,
    });

    loading.hide();

}


</script>
